--[[
	WarriorAlertFu 0.0.1 by LordRhys
	
	Check out readme.txt for more info
]]

local dewdrop = AceLibrary("Dewdrop-2.0")
local tablet = AceLibrary("Tablet-2.0")
local crayon = AceLibrary("Crayon-2.0")

WarriorAlertFu = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0")

WarriorAlertFu.version       = "1.0.0." .. string.sub("$Revision: 36382 $", 12, -3)
WarriorAlertFu.releaseDate   = string.sub("$Date: 2007-05-22 08:00:38 -0500 (Tue, 22 May 2007) $", 8, 17)
WarriorAlertFu.hasIcon = true
WarriorAlertFu.loc = WarriorAlertFuLocals
WarriorAlertFu.defaultPosition = 'LEFT'
WarriorAlertFu.canHideText = true
WarriorAlertFu.clickableTooltip = false

WarriorAlertFu:RegisterDB("WarriorAlertDB") 

WarriorAlertFu:RegisterDefaults('char',{
	WarriorAlertsFu = {
		["Overpower"] = {
			["Message"] = true,
			["Sound"] = true,
			["Battle Stance"] = true,
			["Defensive Stance"] = true,
			["Berserker Stance"] = true,
		},
		["Mortal Strike"] = {       
			["Message"] = true,
			["Sound"] = true,
			["Battle Stance"] = true,
			["Defensive Stance"] = true,
			["Berserker Stance"] = true,
		},
		["Execute"] = {
			["Message"] = true,
			["Sound"] = true,
			["Battle Stance"] = true,
			["Defensive Stance"] = true,
			["Berserker Stance"] = true,
		},
		["Revenge"] = {
			["Message"] = true,
			["Sound"] = true,
			["Battle Stance"] = false,
			["Defensive Stance"] = true,
			["Berserker Stance"] = false,
		},
		["Bloodthirst"] = {
			["Message"] = true,
			["Sound"] = true,
			["Battle Stance"] = true,
			["Defensive Stance"] = true,
			["Berserker Stance"] = true,
		},
	},
	WarriorAlertFuSpellPos = { 
		["Execute"] = {
			["pos"] = 0,
			["inCooldown"] = 0,
			["sekCooldown"] = 0,
			["startTime"] = 0,
			["tab"] = 2,
			["messageShown"] = 0,
			["slot"] = 0,
			["canCast"] = 0,
		},
		["Mortal Strike"] = {
			["pos"] = 0,
			["inCooldown"] = 0,
			["sekCooldown"] = 0,
			["startTime"] = 0,
			["tab"] = 4,
			["messageShown"] = 0,
			["slot"] = 0,
			["canCast"] = 0,
		},
		["Bloodthirst"] = {
			["pos"] = 0,
			["inCooldown"] = 0,
			["sekCooldown"] = 0,
			["startTime"] = 0,
			["tab"] = 2,
			["messageShown"] = 0,
			["slot"] = 0,
			["canCast"] = 0,
		},
		["Overpower"] = {
			["pos"] = 0,
			["inCooldown"] = 0,
			["sekCooldown"] = 0,
			["startTime"] = 0,
			["tab"] = 4,
			["messageShown"] = 0,
			["slot"] = 0,
			["canCast"] = 0,
		},
		["Revenge"] = {
			["pos"] = 0,
			["inCooldown"] = 0,
			["sekCooldown"] = 0,
			["startTime"] = 0,
			["tab"] = 3,
			["messageShown"] = 0,
			["slot"] = 0,
			["canCast"] = 0,
		},
	},
WAFuEnabled = true,
MessageFramePos = "Locked",
	
})

WarriorAlertFu_spellName = {
	"Execute","Overpower","Mortal Strike","Revenge","Bloodthirst",
	}
		
WarriorAlertFu_timeSinceLastUpdate = 0
WarriorAlertFu_LookupDone = 0

local optionsTable = { 
	type = 'group',
 	args = { 
   	Alerts = { 
     	name = "Alerts", 
      type = 'group',
      desc = "Options for Warrior Ability Alerts",
      args = {
       	Overpower = {
         	name = "Overpower",type = 'group',
          desc = "Options for Warrior Ability Overpower",
					args = {
						["Message"] = {
              name = "Message",type = 'toggle',
              desc = "toggles Message",
              usage = "Alerts Overpower Message",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"].Message
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"].Message = not WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"].Message
              end,
            },
						["Sound"] = {
              name = "Sound",type = 'toggle',
              desc = "toggles Sound",
              usage = "Alerts Overpower Sound",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"].Sound
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"].Sound = not WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"].Sound
              end,
            },
						["BattleStance"] = {
              name = "Battle Stance",type = 'toggle',
              desc = "toggles Battle Stance",
              usage = "Alerts Overpower BattleStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"]["Battle Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"]["Battle Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"]["Battle Stance"]
              end,
            },
						["DefensiveStance"] = {
              name = "Defensive Stance",type = 'toggle',
              desc = "toggles Defensive Stance",
              usage = "Alerts Overpower DefensiveStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"]["Defensive Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"]["Defensive Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"]["Defensive Stance"]
              end,
            },
						["BerserkerStance"] = {
              name = "Berserker Stance",type = 'toggle',
              desc = "toggles Berserker Stance",
              usage = "Alerts Overpower BerserkerStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"]["Berserker Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"]["Berserker Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Overpower"]["Berserker Stance"]
              end,
            },
					},
				},
				Execute = {
         	name = "Execute",type = 'group',
          desc = "Options for Warrior Ability Execute",
					args = {
						["Message"] = {
              name = "Message",type = 'toggle',
              desc = "toggles Message",
              usage = "Alerts Execute Message",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Execute"].Message
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Execute"].Message = not WarriorAlertFu.db.char.WarriorAlertsFu["Execute"].Message
              end,
            },
						["Sound"] = {
              name = "Sound",type = 'toggle',
              desc = "toggles Sound",
              usage = "Alerts Execute Sound",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Execute"].Sound
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Execute"].Sound = not WarriorAlertFu.db.char.WarriorAlertsFu["Execute"].Sound
              end,
            },
						["BattleStance"] = {
              name = "Battle Stance",type = 'toggle',
              desc = "toggles Battle Stance",
              usage = "Alerts Execute BattleStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Execute"]["Battle Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Execute"]["Battle Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Execute"]["Battle Stance"]
              end,
            },
						["DefensiveStance"] = {
              name = "Defensive Stance",type = 'toggle',
              desc = "toggles Defensive Stance",
              usage = "Alerts Execute DefensiveStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Execute"]["Defensive Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Execute"]["Defensive Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Execute"]["Defensive Stance"]
              end,
            },
						["BerserkerStance"] = {
              name = "Berserker Stance",type = 'toggle',
              desc = "toggles Berserker Stance",
              usage = "Alerts Execute BerserkerStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Execute"]["Berserker Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Execute"]["Berserker Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Execute"]["Berserker Stance"]
              end,
            },
					},
				},
				MortalStrike = {
         	name = "Mortal Strike",type = 'group',
          desc = "Options for Warrior Ability Mortal Strike",
					args = {
						["Message"] = {
              name = "Message",type = 'toggle',
              desc = "toggles Message",
              usage = "Alerts MortalStrike Message",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"].Message
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"].Message = not WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"].Message
              end,
            },
						["Sound"] = {
              name = "Sound",type = 'toggle',
              desc = "toggles Sound",
              usage = "Alerts MortalStrike Sound",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"].Sound
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"].Sound = not WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"].Sound
              end,
            },
						["BattleStance"] = {
              name = "Battle Stance",type = 'toggle',
              desc = "toggles Battle Stance",
              usage = "Alerts MortalStrike BattleStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"]["Battle Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"]["Battle Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"]["Battle Stance"]
              end,
            },
						["DefensiveStance"] = {
              name = "Defensive Stance",type = 'toggle',
              desc = "toggles Defensive Stance",
              usage = "Alerts MortalStrike DefensiveStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"]["Defensive Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"]["Defensive Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"]["Defensive Stance"]
              end,
            },
						["BerserkerStance"] = {
              name = "Berserker Stance",type = 'toggle',
              desc = "toggles Berserker Stance",
              usage = "Alerts MortalStrike BerserkerStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"]["Berserker Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"]["Berserker Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Mortal Strike"]["Berserker Stance"]
              end,
            },
					},
				},
				Revenge = {
         	name = "Revenge",type = 'group',
          desc = "Options for Warrior Ability Revenge",
					args = {
						["Message"] = {
              name = "Message",type = 'toggle',
              desc = "toggles Message",
              usage = "Alerts Revenge Message",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"].Message
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"].Message = not WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"].Message
              end,
            },
						["Sound"] = {
              name = "Sound",type = 'toggle',
              desc = "toggles Sound",
              usage = "Alerts Revenge Sound",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"].Sound
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"].Sound = not WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"].Sound
              end,
            },
						["BattleStance"] = {
              name = "Battle Stance",type = 'toggle',
              desc = "toggles Battle Stance",
              usage = "Alerts Revenge BattleStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"]["Battle Stance"]
              end,
             -- set = function(v)
             --   WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"]["Battle Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"]["Battle Stance"]
             -- end,
            },
						["DefensiveStance"] = {
              name = "Defensive Stance",type = 'toggle',
              desc = "toggles Defensive Stance",
              usage = "Alerts Revenge DefensiveStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"]["Defensive Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"]["Defensive Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"]["Defensive Stance"]
              end,
            },
						["BerserkerStance"] = {
              name = "Berserker Stance",type = 'toggle',
              desc = "toggles Berserker Stance",
              usage = "Alerts Revenge BerserkerStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"]["Berserker Stance"]
              end,
              -- set = function(v)
              --  WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"]["Berserker Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Revenge"]["Berserker Stance"]
              -- end,
            },
					},
				},
				Bloodthirst = {
         	name = "Bloodthirst",type = 'group',
          desc = "Options for Warrior Ability Bloodthirst",
					args = {
						["Message"] = {
              name = "Message",type = 'toggle',
              desc = "toggles Message",
              usage = "Alerts Bloodthirst Message",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"].Message
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"].Message = not WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"].Message
              end,
            },
						["Sound"] = {
              name = "Sound",type = 'toggle',
              desc = "toggles Sound",
              usage = "Alerts Bloodthirst Sound",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"].Sound
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"].Sound = not WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"].Sound
              end,
            },
						["BattleStance"] = {
              name = "Battle Stance",type = 'toggle',
              desc = "toggles Battle Stance",
              usage = "Alerts Bloodthirst BattleStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"]["Battle Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"]["Battle Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"]["Battle Stance"]
              end,
            },
						["DefensiveStance"] = {
              name = "Defensive Stance",type = 'toggle',
              desc = "toggles Defensive Stance",
              usage = "Alerts Bloodthirst DefensiveStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"]["Defensive Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"]["Defensive Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"]["Defensive Stance"]
              end,
            },
						["BerserkerStance"] = {
              name = "Berserker Stance",type = 'toggle',
              desc = "toggles Berserker Stance",
              usage = "Alerts Bloodthirst BerserkerStance",
              get = function()
                return WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"]["Berserker Stance"]
              end,
              set = function(v)
                WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"]["Berserker Stance"] = not WarriorAlertFu.db.char.WarriorAlertsFu["Bloodthirst"]["Berserker Stance"]
              end,
            },
					},
				},		
			},
		},
	},
}
						
WarriorAlertFu:RegisterChatCommand({"/wafu","/walert"},optionsTable)
WarriorAlertFu.OnMenuRequest = optionsTable										
										
--------------------------------------------------------------------------------
-- functions --------------------------------------------------------------
--------------------------------------------------------------------------------										
										
function WarriorAlertFu:OnInitialize()
	local i;
	local _, class = UnitClass("player");
	
	if(class == "WARRIOR") then
		DEFAULT_CHAT_FRAME:AddMessage("LordRhys's WarriorAlertFu "..self.version.." loaded.") -- (self.loc.WARRIORALERTFu_WELCOME)
		self.db.char.WAFuEnabled = true
		for i=1, 120 do
			self:GetSlots(i);
		end
	else
		-- self:ToggleActivate(false)
		self.db.char.WAFuEnabled = false
		DisableAddOn("WarriorAlertFu")
	end
end

function WarriorAlertFu:OnEnable()
	
		self:RegisterEvent("UNIT_HEALTH","DoExecute")
		self:RegisterEvent("UNIT_RAGE","RageChecks")
		self:RegisterEvent("PLAYER_TARGET_CHANGED","TargetChanged")
		self:RegisterEvent("CHAT_MSG_COMBAT_SELF_MISSES","DoOverpower")
		self:RegisterEvent("CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES","DoRevenge")
		self:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN","DoMortalStrike")
		self:RegisterEvent("SPELL_UPDATE_COOLDOWN","Instant")
		self:RegisterEvent("ACTIONBAR_SLOT_CHANGED","GetSlots")
		self:RegisterEvent("PLAYER_REGEN_DISABLED","LookUpActions")
		self:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE","DoOverpower")	
end

function WarriorAlertFu:RageChecks()
	self:DoExecute()
	self:DoMortalStrike()
	self:DoBloodthirst()
	
end

function WarriorAlertFu:GetSlots(slot)
	
	WarriorAlertFuTooltip:SetOwner(UIParent, "ANCHOR_NONE")
	WarriorAlertFuTooltip:SetAction(slot)
	local n = WarriorAlertFuTooltipTextLeft1:GetText()
	local j = WarriorAlertFuTooltipTextRight3:GetText()
	if (j == nil) then
		j = "0"
	end
	for s,_ in pairs(WarriorAlertFu_spellName) do
		if(n == WarriorAlertFu_spellName[s]) then
			self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["slot"] = slot
			self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["sekCooldown"] = string.gmatch(j, "%d")() + 0

			if(self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["sekCooldown"] < 1.5) then
				self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["sekCooldown"] = 1.5;
			end

			self.CheckSpells();
		end
	end
end

function WarriorAlertFu:CheckSpells()
	local pos = 1
	local spellCount = 0

	for x=1, GetNumSpellTabs() do
		_, _, _, numSpells = GetSpellTabInfo(x)
		spellCount = spellCount + numSpells
	end
DEFAULT_CHAT_FRAME:AddMessage("SpellCount = "..spellCount)
	for x=1, spellCount do
		for s=1, 5 do
			if(string.find(GetSpellName(x, BOOKTYPE_SPELL), WarriorAlertFu_spellName[s])) then
				self.db.char.WarriorAlertFuSpellPos[WarriorAlertFu_spellName[s]]["pos"] = x
			end
		end
	end
end


function WarriorAlertFu:CurrentStance()
	for x=1, GetNumShapeshiftForms() do
		_, stanceName, active = GetShapeshiftFormInfo(x)
		
		if(active == 1) then
			-- return x
			return stanceName
		end
	end
	
	-- return 0;
end



function WarriorAlertFu:Instant()
	for s=1, 5 do
		if(self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["pos"] > 0 and self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["inCooldown"] == 0) then
			local start, duration, flag = GetSpellCooldown(self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["pos"], self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["tab"])
		
			if(self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["sekCooldown"] == duration and start > 0) then
				self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["startTime"] = start
				self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["inCooldown"] = 1
				self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["canCast"] = 0
				self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["messageShown"] = 0
			end
		end
	end
end


function WarriorAlertFu:CheckCooldowns(elapsed)
	local updateInterval = 0.25
	
	WarriorAlertFu_timeSinceLastUpdate = WarriorAlertFu_timeSinceLastUpdate + elapsed 	
	
	if (WarriorAlertFu_timeSinceLastUpdate > updateInterval) then
		WarriorAlertFu_timeSinceLastUpdate = 0
		
		for s=1, 5 do
			if(self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["inCooldown"] == 1) then
				if((self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["sekCooldown"] - (GetTime() - self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["startTime"])) <= 0) then
					self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["inCooldown"] = 0
					self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["messageShown"] = 0
				end
			end
		end
		
		self:DoOverpower("")
		self:DoExecute()
		self:DoRevenge("")
		self:DoMortalStrike()
		
	end
end

function WarriorAlertFu:TargetChanged(unit)
	for s=1, 5 do
		self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["messageShown"] = 0
		self.db.char.WarriorAlertFuSpellPos[ WarriorAlertFu_spellName[s] ]["canCast"] = 0
	end

	self:DoExecute()
end

function WarriorAlertFu:LookUpActions()
	if(WarriorAlertFu_LookupDone == 1) then
		return
	end
	
	WarriorAlertFu_LookupDone = 1
	
	DEFAULT_CHAT_FRAME:AddMessage("WarriorAlertFu: looking up spells...")
	
	for i=1, 120 do
		self:GetSlots(i)
	end
end

--------------------------------------------------------------------------------
-- Execute functions -----------------------------------------------------------
--------------------------------------------------------------------------------
function WarriorAlertFu:DoExecute()
	local stance = self:CurrentStance()
	DEFAULT_CHAT_FRAME:AddMessage("Stance = "..stance)
	if(self.db.char.WarriorAlertsFu["Execute"][stance] == false) then
		return
	end
	
	if(self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_EXECUTE_SPELLNAME ]["pos"] == 0 or
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_EXECUTE_SPELLNAME ]["inCooldown"] == 1 or
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_EXECUTE_SPELLNAME ]["messageShown"] == 1 or
		IsActionInRange(self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_EXECUTE_SPELLNAME ]["slot"]) ~= 1 or
		UnitCanAttack("player", "target") == false) then
		return
	end

	if(UnitHealth("target") > 0 and UnitHealth("target") < 20 and UnitMana("player") >= 15) then
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_EXECUTE_SPELLNAME ]["messageShown"] = 1
		
		if(self.db.char.WarriorAlertsFu["Execute"]["Message"] == true) then
			WarriorAlertFuMessageFrame:AddMessage(self.loc.WARRIORALERTFu_EXECUTE, 1.0, 1.0, 1.0, 1.0, 1)
		end

		if(self.db.char.WarriorAlertsFu["Execute"]["Sound"] == true) then
			PlaySound("igQuestCancel") -- ("igQuestLogAbandonQuest")
		end
	end
end



--------------------------------------------------------------------------------
-- Mortal Strike functions -----------------------------------------------------
--------------------------------------------------------------------------------
function WarriorAlertFu:DoMortalStrike()
	local stance = self:CurrentStance()
	DEFAULT_CHAT_FRAME:AddMessage("Stance for DoMortalStrike = "..stance)
	if(self.db.char.WarriorAlertsFu["Mortal Strike"][stance] == false) then
		return
	end

	if(UnitMana("player") < 30 and self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_MORTALSTRIKE_SPELLNAME ]["inCooldown"] == 0) then
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_MORTALSTRIKE_SPELLNAME ]["messageShown"] = 0;
	end
	
	if(self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_MORTALSTRIKE_SPELLNAME ]["pos"] == 0 or
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_MORTALSTRIKE_SPELLNAME ]["inCooldown"] == 1 or
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_MORTALSTRIKE_SPELLNAME ]["messageShown"] == 1 or
		IsActionInRange(self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_MORTALSTRIKE_SPELLNAME ]["slot"]) ~= 1 or
		UnitCanAttack("player", "target") == false) then
		return
	end
	
	if(UnitHealth("target") > 0 and UnitMana("player") >= 30) then
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_MORTALSTRIKE_SPELLNAME ]["messageShown"] = 1
		
		if(self.db.char.WarriorAlertsFu["Mortal Strike"]["Message"] == true) then
			WarriorAlertFuMessageFrame:AddMessage(self.loc.WARRIORALERTFu_MORTALSTRIKE, 1.0, 1.0, 1.0, 1.0, 1)
		end

		if(self.db.char.WarriorAlertsFu["Mortal Strike"]["Sound"] == true) then
			PlaySound("igQuestCancel") -- ("igQuestLogAbandonQuest")
		end
	end

end



--------------------------------------------------------------------------------
-- Bloodthirst functions -------------------------------------------------------
--------------------------------------------------------------------------------
function WarriorAlertFu:DoBloodthirst()
	local stance = self:CurrentStance()
	if(self.db.char.WarriorAlertsFu["Bloodthirst"][stance] == false) then
		return;
	end
	
	if(self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_BLOODTHIRST_SPELLNAME ]["pos"] == 0 or
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_BLOODTHIRST_SPELLNAME ]["inCooldown"] == 1 or
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_BLOODTHIRST_SPELLNAME ]["messageShown"] == 1 or
		IsActionInRange(self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_BLOODTHIRST_SPELLNAME ]["slot"]) ~= 1 or
		UnitCanAttack("player", "target") == false) then
		return;
	end
	
	if(UnitHealth("target") > 0 and UnitMana("player") >= 30) then
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_BLOODTHIRST_SPELLNAME ]["messageShown"] = 1;
		
		if(self.db.char.WarriorAlertsFu["Bloodthirst"]["Message"] == true) then
			WarriorAlertFuMessageFrame:AddMessage(self.loc.WARRIORALERTFu_BLOODTHIRST, 1.0, 1.0, 1.0, 1.0, 0.1);
		end
		
		if(self.db.char.WarriorAlertsFu["Bloodthirst"]["Sound"] == true) then
			PlaySound("igQuestCancel") -- ("igQuestLogAbandonQuest")
		end
	end
end



--------------------------------------------------------------------------------
-- Overpower functions ---------------------------------------------------------
--------------------------------------------------------------------------------
function WarriorAlertFu:DoOverpower(msg)
	local stance = self:CurrentStance()
	if(self.db.char.WarriorAlertsFu["Overpower"][stance] == false) then
		return
	end
	
	for s in pairs(self.loc.WARRIORALERTFu_Overpower_MSG) do
		if(string.find(msg, self.loc.WARRIORALERTFu_Overpower_MSG[s])) then
			self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_Overpower_SPELLNAME ]["canCast"] = 1;
		end
	end
	
	if(self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_Overpower_SPELLNAME ]["pos"] == 0 or
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_Overpower_SPELLNAME ]["inCooldown"] == 1 or
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_Overpower_SPELLNAME ]["messageShown"] == 1 or
		IsActionInRange(self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_Overpower_SPELLNAME ]["slot"]) ~= 1) then
		return
	end

	if(UnitMana("player") >= 5 and self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_Overpower_SPELLNAME ]["canCast"] == 1) then
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_Overpower_SPELLNAME ]["messageShown"] = 1
		
		if(self.db.char.WarriorAlertsFu["Overpower"]["Message"] == true) then
			WarriorAlertFuMessageFrame:AddMessage(self.loc.WARRIORALERTFu_Overpower, 1.0, 1.0, 1.0, 1.0, 1)
		end

		if(self.db.char.WarriorAlertsFu["Overpower"]["Sound"] == true) then
			PlaySound("igQuestCancel") -- ("igQuestLogAbandonQuest")
		end
	end
end



--------------------------------------------------------------------------------
-- Revenge functions -----------------------------------------------------------
--------------------------------------------------------------------------------
function WarriorAlertFu:DoRevenge(msg)
	if(self.db.char.WarriorAlertsFu["Revenge"][ self:CurrentStance() ] == false) then
		return
	end
	
	for s in pairs(self.loc.WARRIORALERTFu_REVENGE_MSG) do
		if(string.find(msg, self.loc.WARRIORALERTFu_REVENGE_MSG[s])) then
			self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_REVENGE_SPELLNAME ]["canCast"] = 1
		end
	end
	
	if(self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_REVENGE_SPELLNAME ]["pos"] == 0 or
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_REVENGE_SPELLNAME ]["messageShown"] == 1 or
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_REVENGE_SPELLNAME ]["inCooldown"] == 1 or
		IsActionInRange(self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_REVENGE_SPELLNAME ]["slot"]) ~= 1 or
		UnitCanAttack("player", "target") == false) then
		return
	end

	if(UnitHealth("target") > 0 and UnitMana("player") >= 5 and self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_REVENGE_SPELLNAME ]["canCast"] == 1) then
		self.db.char.WarriorAlertFuSpellPos[ self.loc.WARRIORALERTFu_REVENGE_SPELLNAME ]["messageShown"] = 1
		
		if(self.db.char.WarriorAlertsFu["Revenge"]["Message"] == true) then
			WarriorAlertFuMessageFrame:AddMessage(self.loc.WARRIORALERTFu_REVENGE, 1.0, 1.0, 1.0, 1.0, 1)
		end

		if(self.db.char.WarriorAlertsFu["Revenge"]["Sound"] == true) then
			PlaySound("igQuestCancel") -- ("igQuestLogAbandonQuest")
		end
	end
end

--------------------------------------------------------------------------------
-- FuBar functions ---------------------------------------------------------
--------------------------------------------------------------------------------

-- function WarriorAlertFu:OnTextUpdate()
  	-- self:SetText("WarriorAlertFu Enabled: "..self.db.char.WAFuEnabled)
-- end

function WarriorAlertFu:OnTooltipUpdate()

	tablet:SetHint(crayon:White("MessageFrame is: ")..crayon:Purple(self.db.char["MessageFramePos"])..crayon:White(" Click to Lock or Unlock it."))
	-- as a rule, if you have an OnClick or OnDoubleClick or OnMouseUp or OnMouseDown, you should set a hint.
end

function FactionItemsFu:OnClick()
  if self.db.char["MessageFramePos"] == "Locked" then
  	self:Command(unlock)
  else
  	self:Command(lock)
  end
end

function WarriorAlertFu:Command(cmd)
	if(cmd == "") then
		return
	end
	
	if(cmd == "unlock") then
		WarriorAlertFuMessageFrame:RegisterForDrag("LeftButton");
		WarriorAlertFuMessageFrame:EnableMouse(true);
		WarriorAlertFuMessageFrame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 32, edgeSize = 32, 
                                            insets = { left = 8, right = 8, top = 8, bottom = 8 }});
    self.db.char["MessageFramePos"] = "UnLocked"
	end
	
	if(cmd == "lock") then
		WarriorAlertFuMessageFrame:RegisterForDrag();
		WarriorAlertFuMessageFrame:SetBackdrop(nil);
		WarriorAlertFuMessageFrame:EnableMouse(false);
		self.db.char["MessageFramePos"] = "Locked"
	end
end